// InputDialNumber.cpp : implementation file
//

#include "stdafx.h"
#include "Dial Application.h"
#include "InputDialNumber.h"

#include "CommunicationControl.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInputDialNumber dialog
CString vNumberDial;

CInputDialNumber::CInputDialNumber(CWnd* pParent /*=NULL*/)
	: CDialog(CInputDialNumber::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInputDialNumber)
	m_edtime2 = _T("");
	m_edtime1 = _T("");
	m_edstart = _T("");
	m_edtimeampm = _T("");
	m_edmstart = _T("");
	m_edmstop = _T("");
	m_edinterval = 0.0;
	m_edminterval = 0.0;
	m_vmanual = _T("");
	m_vcallinputbuffercount = 0;
	m_dialsystem = _T("");
	//}}AFX_DATA_INIT
}


void CInputDialNumber::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputDialNumber)
	DDX_Control(pDX, IDC_CANCELDIAL, m_bcanceld);
	DDX_Control(pDX, IDC_STOP, m_bstop);
	DDX_Control(pDX, IDC_START, m_bstart);
	DDX_Control(pDX, ID_CALLD, m_bcalld);
	DDX_Control(pDX, IDC_EDMSTART, m_edmstartcontrol);
	DDX_Control(pDX, IDC_NUMBERDIAL, m_editnumberdial);
	DDX_Text(pDX, IDC_EDTIME2, m_edtime2);
	DDX_Text(pDX, IDC_EDTIME1, m_edtime1);
	DDX_Text(pDX, IDC_EDSTART, m_edstart);
	DDX_Text(pDX, IDC_EDTIMEAMPM, m_edtimeampm);
	DDX_Text(pDX, IDC_EDMSTART, m_edmstart);
	DDX_Text(pDX, IDC_EDMSTOP, m_edmstop);
	DDX_Text(pDX, IDC_EDINTERVAL, m_edinterval);
	DDX_Text(pDX, IDC_EDMINTERVAL, m_edminterval);
	DDX_Text(pDX, IDC_VMANUAL, m_vmanual);
	DDX_Text(pDX, IDC_VCALLINPUTBUFFERCOUNT, m_vcallinputbuffercount);
	DDX_Text(pDX, IDC_STATICDIALSYSTEM, m_dialsystem);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInputDialNumber, CDialog)
	//{{AFX_MSG_MAP(CInputDialNumber)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(ID_RESUME, OnResume)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(ID_CALLD, OnCalld)
	ON_BN_CLICKED(IDC_CANCELDIAL, OnCanceldial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInputDialNumber message handlers

BOOL CInputDialNumber::OnInitDialog() 
{
	CDialog::OnInitDialog();
    
	//Test, close any port open
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
	if (pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(FALSE);

	SetLocalTime(&systime);
	m_uTimerID = SetTimer(IDD_INPUT_DIAL,1,NULL);

	GetDlgItem(IDC_NUMBERDIAL)->SetFocus();

	//Initial flag interval
	flginterval = false;
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CInputDialNumber::OnCalld()
{

	VARIANT var;
	CString str,vNumberDial;

	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();

	if (!pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(TRUE);

	// NOTE: Modem command string will differ according to
	// modem type. Check documentation included with modem to
	// determine the correct command string to autodial.
	m_editnumberdial.GetWindowText(vNumberDial);
	str.Format(IDS_DIALCOMMAND,vNumberDial);
	
	var.vt = VT_BSTR;
	var.bstrVal = str.AllocSysString();
	pMainWnd->GetMSComm()->SetOutput(var);
	SysFreeString(var.bstrVal);

	time( &startd );
	m_edstart = m_edtime2;

	m_vcallinputbuffercount	= pMainWnd->GetMSComm()->GetInBufferCount();

	m_bcanceld.EnableWindow(TRUE);
	m_bcalld.EnableWindow(FALSE);
	GetDlgItem(IDC_EDSTART)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDINTERVAL)->EnableWindow(FALSE);
	GetDlgItem(IDC_NUMBERDIAL)->EnableWindow(FALSE);
    
	//Interval Flag is true;
	flginterval = true;
	// TODO: Add your control notification handler code here
}

void CInputDialNumber::OnStart() 
{

	m_bstop.EnableWindow(TRUE);
	m_bstart.EnableWindow(FALSE);
	GetDlgItem(IDC_EDMSTART)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDMSTOP)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDMINTERVAL)->EnableWindow(FALSE);	

	m_edmstart = m_edtime2;
	m_vmanual = "yes";
	m_edminterval = 0;
	time( &start );

	// TODO: Add your control notification handler code here
}

void CInputDialNumber::OnStop() 
{
	m_bstop.EnableWindow(FALSE);
	m_bstart.EnableWindow(TRUE);

	GetDlgItem(IDC_EDMSTART)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDMSTOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDMINTERVAL)->EnableWindow(TRUE);	

	m_vmanual = "no";
	m_edmstop = m_edtime2;

	time( &finish );
	m_edminterval = difftime( finish, start );

    flginterval = false;
     
  
	// TODO: Add your control notification handler code here
	
}

void CInputDialNumber::OnResume() 
{
	CCommunicationControl dlgCom;
	dlgCom.DoModal();
	
	// TODO: Add your control notification handler code here
}

void CInputDialNumber::OnDestroy() 
{
	CDialog::OnDestroy();

	KillTimer(m_uTimerID);
	
	// TODO: Add your message handler code here
}

void CInputDialNumber::OnCanceldial() 
{
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();

	if (pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(FALSE);

      flginterval = false;
     
	// TODO: Add your control notification handler code here

}

void CInputDialNumber::OnTimer(UINT nIDEvent) 
{
	CHAR sz0[40], sz1[10], sz2[40];
	tm *vtm;
	time_t vtime_t;

	time(&vtime_t);
	vtm = localtime(&vtime_t);

//***************************** m_edtime1 = sz2 ******************
	GetLocalTime(&systime);

    itoa(systime.wHour, sz2, 10);
	strcat(sz2, " : ");
    itoa(systime.wMinute, &sz2[strlen(sz2)], 10);
    strcat(sz2, " : ");
    itoa(systime.wSecond, &sz2[strlen(sz2)], 10);
	strcat(sz2, " : ");
	itoa(systime.wMilliseconds, &sz2[strlen(sz2)], 10);

    m_edtime1 = sz2;
//**************************** m_edtimeampm = sz1 *******************	
	if (vtm->tm_hour > 12)
		itoa(vtm->tm_hour - 12 , sz1, 10);
	else
		itoa(vtm->tm_hour, sz1, 10);

    strcat(sz1, " : ");
    itoa(vtm->tm_min, &sz1[strlen(sz1)], 10);
    strcat(sz1, " : ");
    itoa(vtm->tm_sec, &sz1[strlen(sz1)], 10);
	strcat(sz1, ":");
	if (vtm->tm_hour > 12)
		strcat(sz1, " PM");
	else
		strcat(sz1, " AM");

	m_edtimeampm = sz1;

//****************************** m_edtime2 = sz0 ******************

    itoa(vtm->tm_hour, sz0, 10);
    strcat(sz0, " : ");
    itoa(vtm->tm_min, &sz0[strlen(sz0)], 10);
    strcat(sz0, " : ");
    itoa(vtm->tm_sec, &sz0[strlen(sz0)], 10);

	m_edtime2 = sz0;
//**************************** m_edmstop = sz0 ***********************
	if (m_vmanual == "yes")
		m_edmstop = sz0;
//**************************** MSComm /Dial Phone ********************

	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();

	//Dial Timer
	if ((pMainWnd->GetMSComm()->GetPortOpen())  && 
		(pMainWnd->GetMSComm()->GetInBufferCount() == m_vcallinputbuffercount)) {

		time( &finishd );
		if (flginterval)
           m_edinterval = difftime( finishd, startd );
         
		GetDlgItem(IDC_EDSTART)->EnableWindow(TRUE);

	}

	else
	{
		if (pMainWnd->GetMSComm()->GetPortOpen())
			pMainWnd->GetMSComm()->SetPortOpen(FALSE);
		
		GetDlgItem(IDC_CANCELDIAL)->EnableWindow(FALSE);
	}


	if (pMainWnd->GetMSComm()->GetPortOpen())
		m_dialsystem = "Dial System Worked";
	else
	{
		m_dialsystem = "Dial System Stoped";

		m_editnumberdial.GetWindowText(vNumberDial);

		// vNumberDial, Get Lenght
		if (vNumberDial.GetLength() != 0)
			m_bcalld.EnableWindow(TRUE);

		m_bcanceld.EnableWindow(FALSE);
		GetDlgItem(IDC_EDSTART)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDINTERVAL)->EnableWindow(TRUE);
		GetDlgItem(IDC_NUMBERDIAL)->EnableWindow(TRUE);

	}

	UpdateData(FALSE);


	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}
