// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Dial Application.h"

#include "MainFrm.h"
#include "InputDialNumber.h"
#include "CommunicationControl.h"
#include "SettingDialerProperties.h"
#include "MonthCalendar.h"

#include "io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_DIALINFO_COMMUNICATIONINFO, OnDialinfoCommunicationinfo)
	ON_COMMAND(ID_DIALINFO_MONTHCALENDAR, OnDialinfoMonthcalendar)
	ON_COMMAND(ID_DIALINFO_SETTINGDIALERINFO, OnDialinfoSettingdialerinfo)
	ON_COMMAND(ID_DIALOPERATION_DIALNUMBERCALL, OnDialoperationDialnumbercall)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
//****************************** MSCOMM Control *************************
	// Create the MSCOMM  Control.
	if (!m_mscomm.Create(NULL,0,CRect(0,0,0,0),this,ID_MSCOMM))
	{
		TRACE0("Failed to create OLE Communications Control\n");
		return -1;      // fail to create
	}


	// Set RThreshold property to 1. The default RThreshold value (0)
	// causes the OnComm event to NOT fire when a character is detected
	// in the serial port.
	m_mscomm.SetRThreshold(1);


	m_uTimerID = SetTimer(ID_TIMER,1,NULL);
	return 0;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style &= ~WS_MAXIMIZEBOX;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
void CMainFrame::OnDialinfoCommunicationinfo() 
{
	CCommunicationControl dlgP;
	dlgP.DoModal();

	// TODO: Add your command handler code here
}

void CMainFrame::OnDialinfoMonthcalendar() 
{
	CMonthCalendar dlgM;
	dlgM.DoModal();
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnDialinfoSettingdialerinfo() 
{
	CSettingDialerProperties dlgDial(this);
	int NCom = m_mscomm.GetCommPort();
	dlgDial.m_nport = NCom;

	char StrNCom[1];
	_itoa(NCom,StrNCom,10);

	CString str("COM");
	str.Insert(3,StrNCom);

	dlgDial.m_strComPort = str;

	dlgDial.DoModal();
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnDialoperationDialnumbercall() 
{
	CInputDialNumber dlgH(this);
	dlgH.DoModal();
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{

	CHAR sz[40];
	SYSTEMTIME systime;
	GetLocalTime(&systime);

    itoa(systime.wHour, sz, 10);
	strcat(sz, ":");
    itoa(systime.wMinute, &sz[strlen(sz)], 10);
    strcat(sz, ":");
    itoa(systime.wSecond, &sz[strlen(sz)], 10);

	m_wndStatusBar.SetPaneText(2,sz,TRUE);

	// TODO: Add your message handler code here and/or call default
	
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	
	KillTimer(m_uTimerID);
	// TODO: Add your message handler code here
	
}
