// SettingDialerProperties.cpp : implementation file
//

#include "stdafx.h"
#include "Dial Application.h"
#include "SettingDialerProperties.h"

#include "CommunicationControl.h"

#include "io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingDialerProperties dialog
CImageList* CSettingDialerProperties::m_pImageListP = 0;

CSettingDialerProperties::CSettingDialerProperties(CMainFrame* pParent /*=NULL*/)
	: CDialog(CSettingDialerProperties::IDD, pParent)
{
   
	int  cxSmIcon = GetSystemMetrics(SM_CXSMICON);				
    int  cySmIcon = GetSystemMetrics(SM_CYSMICON);
	
	if (!m_pImageListP)
	{
		m_pImageListP = new CImageList;
    
  		 //create the image list
		m_pImageListP ->Create(cxSmIcon, cySmIcon, ILC_COLORDDB, IDI_ICOMODEM - IDI_ICOPORT, 10);
	}

	//{{AFX_DATA_INIT(CSettingDialerProperties)
	m_strComboDataBits = _T("");
	m_strComboStopBits = _T("");
	m_strComboParity = _T("");
	m_strComboMaxSpeed = _T("");
	m_strsetting = pParent->GetMSComm()->GetSettings();
	m_strComPort = _T("");
	m_CheckFlow = FALSE;
	m_RFlow = -1;
	m_nport = pParent->GetMSComm()->GetCommPort();//0;
	m_Handshaking = pParent->GetMSComm()->GetHandshaking();//0;
	//}}AFX_DATA_INIT

}

void CSettingDialerProperties::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingDialerProperties)
	DDX_Control(pDX, IDC_FLOW1009, m_CheckFlowControl);
	DDX_Control(pDX, IDC_LIST1027, m_ListCom);
	DDX_Control(pDX, IDC_COMBO_STOP_BITS, m_ComboStopBitsControl);
	DDX_Control(pDX, IDC_COMBO_MAX_SPEED, m_ComboMaxSpeedControl);
	DDX_Control(pDX, IDC_COMBO_PARITY, m_ComboParityControl);
	DDX_Control(pDX, IDC_COMBO_DATA_BITS, m_ComboDataBitsControl);
	DDX_CBString(pDX, IDC_COMBO_DATA_BITS, m_strComboDataBits);
	DDX_CBString(pDX, IDC_COMBO_STOP_BITS, m_strComboStopBits);
	DDX_CBString(pDX, IDC_COMBO_PARITY, m_strComboParity);
	DDX_CBString(pDX, IDC_COMBO_MAX_SPEED, m_strComboMaxSpeed);
	DDX_Text(pDX, IDC_SETTING, m_strsetting);
	DDX_Text(pDX, IDC_PORT1022, m_strComPort);
	DDX_Check(pDX, IDC_FLOW1009, m_CheckFlow);
	DDX_Radio(pDX, IDC_RFLOW1, m_RFlow);
	DDX_Text(pDX, IDC_NPORT, m_nport);
	DDX_Text(pDX, IDC_HANDSHAKING, m_Handshaking);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingDialerProperties, CDialog)
	//{{AFX_MSG_MAP(CSettingDialerProperties)
	ON_BN_CLICKED(ID_APPLY, OnApply)
	ON_BN_CLICKED(ID_RESUME, OnResume)
	ON_CBN_SELCHANGE(IDC_COMBO_DATA_BITS, OnSelchangeComboDataBits)
	ON_CBN_SELCHANGE(IDC_COMBO_MAX_SPEED, OnSelchangeComboMaxSpeed)
	ON_CBN_SELCHANGE(IDC_COMBO_PARITY, OnSelchangeComboParity)
	ON_CBN_SELCHANGE(IDC_COMBO_STOP_BITS, OnSelchangeComboStopBits)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	ON_BN_CLICKED(IDC_FLOW1009, OnFlow1009)
	ON_BN_CLICKED(IDC_RFLOW1, OnRflow1)
	ON_BN_CLICKED(IDC_RFLOW2, OnRflow2)
	ON_BN_CLICKED(IDC_RFLOW3, OnRflow3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingDialerProperties message handlers

void CSettingDialerProperties::OnNewFList()
{
	int	nNewItem1;
	int nico;
	int j ;
	int k ;

	int NCom1 = m_nport - 1;

	for (int i = 0; i < 3; i++)
	{
		k = j = i;
		j++;
		nNewItem1 = 0;
		CString str("COM");
		CString str1 = "";

		char StrNCom[1] = "";
		_itoa(j,StrNCom,10);
		str.Insert(3,StrNCom);
	
		str1 = " Modem Installed";
		nico = 1; //IDI_ICOMODEM

	
		if (k != NCom1)
		{
			str1 = "no Modem Installed";
			nico = 0; //IDI_ICOPORT

		}

        nNewItem1 = m_ListCom.InsertItem(i,str,nico);
        m_ListCom.SetItem(nNewItem1,1,LVIF_TEXT,str1,0,0,0,0);
				   
		str1 = "";
	}
	
}

void CSettingDialerProperties::OnInitCombo()
{
		// clear out any items in max speed control
	m_ComboMaxSpeedControl.ResetContent();

	m_ComboMaxSpeedControl.AddString("100");
	m_ComboMaxSpeedControl.AddString("300");
	m_ComboMaxSpeedControl.AddString("1200");
	m_ComboMaxSpeedControl.AddString("2400");
	m_ComboMaxSpeedControl.AddString("4800");
	m_ComboMaxSpeedControl.AddString("9600");
	m_ComboMaxSpeedControl.AddString("19200");
	m_ComboMaxSpeedControl.AddString("38400");
	m_ComboMaxSpeedControl.AddString("57600");
	m_ComboMaxSpeedControl.AddString("115200");

	// clear out any items in data bits control
	m_ComboDataBitsControl.ResetContent();

	m_ComboDataBitsControl.AddString("4");
	m_ComboDataBitsControl.AddString("5");
	m_ComboDataBitsControl.AddString("6");
	m_ComboDataBitsControl.AddString("7");
	m_ComboDataBitsControl.AddString("8");


	// clear out any items in parity control
	m_ComboParityControl.ResetContent();

	m_ComboParityControl.AddString("Even");
	m_ComboParityControl.AddString("Odd");
	m_ComboParityControl.AddString("None");
	m_ComboParityControl.AddString("Mark");
	m_ComboParityControl.AddString("Space");


	// clear out any items in stop bits control
	m_ComboStopBitsControl.ResetContent();

	m_ComboStopBitsControl.AddString("1");
	m_ComboStopBitsControl.AddString("1.5");
	m_ComboStopBitsControl.AddString("2");

	OnFlow();

	UpdateData(FALSE);

}

void CSettingDialerProperties::OnSettings()
{
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
	
    if (!pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(TRUE);
	
	CString sting = pMainWnd->GetMSComm()->GetSettings();
	int ofset;
	int lspeed = sting.Find(",");

	//the left part of Settings, max speed
	CString mspeed = sting.Left(lspeed);

	//the midium part of Settings, party
	CString party = sting.Mid(lspeed + 1,1);

	//the midium part of Settings data bits
	CString databit = sting.Mid(lspeed + 3,1);

	//the right most part of Settings, will be 1 or 3 char stop bits
	CString stopbit;
	if (sting.Find(".") > 0)
	{
		ofset = 2;
		stopbit = sting.Right(3);
	}
	else
	{
		ofset = 0;
		stopbit = sting.Right(1);
	}
	
		if ( mspeed == "100" )
			m_ComboMaxSpeedControl.SetCurSel(0);
		else
		{
			if ( mspeed == "300" )		
				m_ComboMaxSpeedControl.SetCurSel(1);
			else
			{
				if ( mspeed == "1200" )		
					m_ComboMaxSpeedControl.SetCurSel(2);
				else
				{
					if ( mspeed == "2400" )		
						m_ComboMaxSpeedControl.SetCurSel(3);
					else
					{
						if ( mspeed == "4800" )		
							m_ComboMaxSpeedControl.SetCurSel(4);
						else
						{
							if ( mspeed == "9600" )		
								m_ComboMaxSpeedControl.SetCurSel(5);
							else
							{
								if ( mspeed == "19200" )		
									m_ComboMaxSpeedControl.SetCurSel(6);
								else
								{
									if ( mspeed == "38400" )		
										m_ComboMaxSpeedControl.SetCurSel(7);
									else
									{
										if ( mspeed == "57600" )		
											m_ComboMaxSpeedControl.SetCurSel(8);
										else
										{
											if ( mspeed == "115200" )			
												m_ComboMaxSpeedControl.SetCurSel(9);
				
										}
									}
								}
							}	
						}
					}
				}
			}
		}

		if ( party == "e" )		
			m_ComboParityControl.SetCurSel(0);
		else
		{
			if ( party == "o" )		
				m_ComboParityControl.SetCurSel(1);
			else
			{
			    if ( party == "n" )		
					m_ComboParityControl.SetCurSel(2);
				else
				{
				    if ( party == "m" )		
						m_ComboParityControl.SetCurSel(3);
					else
					{
						if ( party == "s" )		
							m_ComboParityControl.SetCurSel(4);
					}
				}
			}
		}
	
	   if ( databit == "4" )
			m_ComboDataBitsControl.SetCurSel(0);
		else
		{
		   if ( databit == "5" )
				m_ComboDataBitsControl.SetCurSel(1);
			else
			{
			   if ( databit == "6" )
					m_ComboDataBitsControl.SetCurSel(2);
				else
				{
				   if ( databit == "7" )
						m_ComboDataBitsControl.SetCurSel(3);
					else
					{
						if ( databit == "8" )
							m_ComboDataBitsControl.SetCurSel(4);
	
					}
				}
			}
		}
    
		if( stopbit == "1" )		
			m_ComboStopBitsControl.SetCurSel(0);
		else
		{
			if( stopbit == "1.5" )		
				m_ComboStopBitsControl.SetCurSel(1);
			else
			{
				if( stopbit == "2" )		
					m_ComboStopBitsControl.SetCurSel(2);
			}
		}

}

BOOL CSettingDialerProperties::OnInitDialog() 
{
	CDialog::OnInitDialog();


    UINT Index;
    HICON hIcon;

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	pSysMenu->RemoveMenu(SC_SIZE, MF_BYCOMMAND);
	pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);	

	   //  Initialize the image list with all of the icons 
   	for (Index = IDI_ICOPORT; Index <= IDI_ICOMODEM; Index++)
    {
	 	hIcon = AfxGetApp()->LoadIcon(MAKEINTRESOURCE(Index)); 
		m_pImageListP ->Replace( -1, hIcon);
	}
//******************************************************************
	 //images count 
     int imagct = m_pImageListP ->GetImageCount();
//******************************************************************
	m_ListCom.SetImageList(m_pImageListP,LVSIL_SMALL);

	m_ListCom.InsertColumn(0,"Port",LVCFMT_LEFT,100);
	m_ListCom.InsertColumn(1,"Installed",LVCFMT_LEFT,190);

	OnNewFList();
	OnInitCombo();
	OnSettings();

  // TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CSettingDialerProperties::OnApplyButton(BOOL bEnable)
{
	CButton *pButton;
	pButton = (CButton *) GetDlgItem(ID_APPLY);
	if (pButton != NULL)
		pButton->EnableWindow(bEnable);
}

void CSettingDialerProperties::OnResumeButton(BOOL bEnable)
{
	CButton *pButton;
	pButton = (CButton *) GetDlgItem(ID_RESUME);
	if (pButton != NULL)
		pButton->EnableWindow(bEnable);
}

void CSettingDialerProperties::OnCheckValue()
{
	CButton *pButton0;
	CButton *pButton1;
	CButton *pButton2;
	CButton *pButton3;
	pButton0 = (CButton *) GetDlgItem(IDC_FLOW1009);
	pButton1 = (CButton *) GetDlgItem(IDC_RFLOW1);
	pButton2 = (CButton *) GetDlgItem(IDC_RFLOW2);
	pButton3 = (CButton *) GetDlgItem(IDC_RFLOW3);

	if (pButton0->GetCheck() == 1)
	{
		m_RFlow = 0;
		pButton1->SetCheck(1);
		pButton2->SetCheck(0);
		pButton3->SetCheck(0);
	}
	else 
	{
		m_RFlow = 3;
		pButton1->SetCheck(0);
		pButton2->SetCheck(0);
		pButton3->SetCheck(0);
	}
}

void CSettingDialerProperties::OnSelchangeComboMaxSpeed() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
  // TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnSelchangeComboDataBits() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnSelchangeComboParity() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnSelchangeComboStopBits() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnRflow1() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnFlow1009() 
{
	OnResumeButton(FALSE);
	OnApplyButton(TRUE);
	OnCheckValue();	
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnRflow2() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnRflow3() 
{
	OnApplyButton(TRUE);
	OnResumeButton(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CSettingDialerProperties::OnFlow()
{
	switch ( m_Handshaking )
	{
		case 0: m_RFlow = m_Handshaking;
			    m_CheckFlow = TRUE;
				break;

		case 1: m_RFlow = m_Handshaking;
		    	m_CheckFlow = TRUE;
				break;
		case 2: m_RFlow = m_Handshaking;
				m_CheckFlow = TRUE;
				break;
		default:
			    m_CheckFlow = FALSE;
				break;

	}
//	UpdateData(FALSE);
}

void CSettingDialerProperties::OnSetOk()
{
	// update various dialog data members
	if (!UpdateData(TRUE))
	{
		AfxMessageBox(IDS_UPDATEDATAFAILED);
		return;
	}

	// set commctrl properties to current dialog settings
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
	
   if (!pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(TRUE);
		
	pMainWnd->GetMSComm()->SetDTREnable(TRUE);
	
	CString str;
	CString vparity;

	if ( m_strComboParity == "Even" )
		vparity ="e";
	else
	{
		if ( m_strComboParity == "Odd" )
			vparity ="o";
		else
		{
			if ( m_strComboParity == "None" )
				vparity ="n";
			else
			{
				if ( m_strComboParity == "Mark" )
					vparity ="m";
				else
				{
					if ( m_strComboParity == "Space" )
						vparity ="s";
				}
			}
		}
	}

	str.Format(_T("%s,%s,%s,%s"),m_strComboMaxSpeed,vparity,m_strComboDataBits,m_strComboStopBits);

	pMainWnd->GetMSComm()->SetSettings(str);

	//handshaking (flow)
	if ( m_CheckFlow == TRUE )
		pMainWnd->GetMSComm()->SetHandshaking(m_RFlow);
	else
		pMainWnd->GetMSComm()->SetHandshaking(3);


	if (pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(FALSE);

	UpdateData(FALSE);

}

void CSettingDialerProperties::OnResume() 
{
	CCommunicationControl dlgP;
	dlgP.DoModal();

	// TODO: Add your control notification handler code here
}

void CSettingDialerProperties::OnDefault() 
{
//WS_DISABLED
	// set commctrl properties to current dialog settings
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();

	OnFlow();
	UpdateData(FALSE);

	pMainWnd->GetMSComm()->SetSettings(m_strsetting); 
	OnSettings();

	// TODO: Add your control notification handler code here
}

void CSettingDialerProperties::OnOK() 
{
	OnSetOk();

	EndDialog(IDOK);

	CDialog::OnOK();
}

void CSettingDialerProperties::OnCancel() 
{
	OnDefault();
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CSettingDialerProperties::OnApply() 
{
	
	OnSetOk();
	OnApplyButton(FALSE);
	OnResumeButton(TRUE);

	// TODO: Add your control notification handler code here
}
